// Copyright 2004 Adam Megacz, see the COPYING file for licensing [GPL]
package org.ibex.plat;

import org.ibex.*;
import org.ibex.util.*;
import java.io.*;
import java.security.*;
import java.security.cert.*;

/** common superclass for all platforms that use GCJ to compile a native binary */
public abstract class GCJ extends Platform {

    // static references to these classes ensure that the linker will include them
    public static Object c1 = new gnu.java.locale.Calendar();
        //    public static Object[][] c1c = new gnu.java.locale.Calendar().getContents();
    public static Object c2 = new java.util.GregorianCalendar();
    public static Object c3n = new gnu.gcj.convert.Input_ASCII();
    public static Object c4 = new gnu.gcj.convert.Input_UTF8();
    public static Object c5 = new gnu.gcj.convert.Input_8859_1();
    public static Object c6 = new gnu.java.locale.LocaleInformation();
    public static Object c7 = new gnu.gcj.convert.Output_ASCII();
    //public static Object c8 = new gnu.java.locale.Calendar_en();
    //public static Object c9 = new gnu.java.locale.Calendar_en_US();
    public static Object c10 = new gnu.gcj.protocol.http.Handler();
    public static Object c11 = new gnu.gcj.protocol.jar.Handler();
    public static Object c12 = new java.security.cert.Certificate("foo") { 
            public byte[] getEncoded() throws CertificateEncodingException { return null; }
            public void verify(PublicKey key) { }
            public void verify(PublicKey key, String sigProvider) { }
            public String toString() { return "foocert"; }
            public PublicKey getPublicKey() { return null; }
        };


    protected native InputStream _getBuiltinInputStream();

    protected native void _decodeJPEG(InputStream is, Picture p);

    // FEATURE: This could be optimized (a lot) by using a custom hashtable
    public final static class Retainer {
        private static Hash table = new Hash();
        private final static class Key {
            private Object o;
            public Key(Object o) { this.o = o; }
            public int hashCode() { return o == null ? 0 : o.hashCode(); }
            public boolean equals(Object o2) { return (o2 instanceof Key) && ((Key)o2).o == o; }
        }
        private final static class Entry {
            private int refCount;
            public Entry() { inc(); }
            public void inc() { refCount++; }
            public boolean dec() { return --refCount == 0; }
        }
        public static synchronized void retain(Object o) {
            Key k = new Key(o);
            Entry r = (Entry) table.get(k);
            if(r == null) table.put(k,new Entry());
            else r.inc();
        }
        public static synchronized void release(Object o) {
            Key k = new Key(o);
            Entry e = (Entry) table.get(k);
            if(e == null) throw new Error("Retainer::Release on unknown object");
            if(e.dec()) { table.remove(k); }
        }
    }
}
